SystemOrganization addCategory: #'Xenon-Core-ParseNodes'!
SystemOrganization addCategory: #'Xenon-Core-Types'!
SystemOrganization addCategory: #'Xenon-Core-Exceptions'!
SystemOrganization addCategory: #'Xenon-Core'!

!ParseNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 2/27/2012 00:45'!
asXeNode
	self subclassResponsibility! !

!MethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 2/27/2012 00:45'!
asXeNode
	^ XeMethodNode newInstanceFor: self! !

Error subclass: #XeTooManyReturnTypesError
	instanceVariableNames: 'selectorName className returnTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Exceptions'!

!XeTooManyReturnTypesError class methodsFor: 'signaling' stamp: 'BernardoContreras 2/27/2012 03:21'!
signalForSelector: aSelectorName class: aClassName returnTypes: anArray 
	
	^self basicNew initializeSelector: aSelectorName class: aClassName returnTypes: anArray; signal! !

!XeTooManyReturnTypesError methodsFor: 'accessing' stamp: 'BernardoContreras 2/27/2012 03:24'!
initializeSelector: aSelectorName class: aClassName returnTypes: anArray 
	selectorName := aSelectorName.
	className := aClassName.
	returnTypes := anArray.
	self messageText: 'Too many return types for method ' , selectorName , ' in class ',  className, '. actual types: ' ,  returnTypes asString.
	! !

Object subclass: #XeMethodNode
	instanceVariableNames: 'methodNode defaultReturnType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-ParseNodes'!

!XeMethodNode class methodsFor: 'instance creation' stamp: 'BernardoContreras 2/27/2012 02:32'!
newInstanceFor: aMethodNode 
	^ self basicNew initialize: aMethodNode! !

!XeMethodNode methodsFor: 'accessing' stamp: 'BernardoContreras 2/27/2012 03:17'!
defaultReturnType
	| returnTypes |
	returnTypes := self pragmas select: [ :pragma | pragma keyword = #returnType: ].
	returnTypes isEmpty
		ifTrue: [ ^ Smalltalk globals at: defaultReturnType ]
		ifFalse: [ 
			returnTypes size = 1
				ifTrue: [ ^ Smalltalk globals at: returnTypes first arguments first ]
				ifFalse: [ 
					XeTooManyReturnTypesError signalForSelector: methodNode selector class: methodNode methodClass asString returnTypes: returnTypes ] ]! !

!XeMethodNode methodsFor: 'emit code' stamp: 'BernardoContreras 2/27/2012 01:25'!
emitCodeOn: aStream
	self emitDefaultReturnTypeOn: aStream.
	aStream space.
	aStream nextPutAll: methodNode selector asString.
	aStream nextPutAll: '(){'; cr.
	aStream nextPutAll: '}'.
! !

!XeMethodNode methodsFor: 'emit code' stamp: 'BernardoContreras 2/27/2012 01:32'!
emitDefaultReturnTypeOn: aStream 
	self defaultReturnType emitOn: aStream! !

!XeMethodNode methodsFor: 'initialize-release' stamp: 'BernardoContreras 2/27/2012 00:36'!
initialize: aMethodNode 
	methodNode := aMethodNode.
	defaultReturnType := #XeVoid.
	! !

!XeMethodNode methodsFor: 'accessing' stamp: 'BernardoContreras 2/27/2012 01:24'!
pragmas
	^ methodNode properties pragmas! !

Object subclass: #XeTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 2/26/2012 15:38'!
parserClass
	^ Parser! !

!XeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 2/26/2012 17:18'!
translate: aClass
	| stream |
	stream := ReadWriteStream on: (String new: 1000).
	self translate: aClass to: stream.
	^ stream contents! !

!XeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 2/26/2012 17:18'!
translate: aClass to: stream
	| methodToTranslate |
	methodToTranslate := (self parserClass new parse: (aClass sourceCodeAt: #main) class: aClass) asXeNode.
	methodToTranslate emitCodeOn: stream! !

Object subclass: #XeType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

XeType subclass: #XeInt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

!XeInt class methodsFor: 'emit code' stamp: 'BernardoContreras 2/27/2012 01:38'!
emitOn: aStream 
	aStream nextPutAll: 'int'! !

XeType subclass: #XeVoid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

!XeVoid class methodsFor: 'emit code' stamp: 'BernardoContreras 2/27/2012 01:14'!
emitOn: aStream
	aStream nextPutAll: 'void'! !
